const DEBUGGER_TAG = ' @IIFE-for-debug';

module.exports = function DebugBlock({ types: t }) {
    return {
        visitor: {
            Program(p) {
                p.traverse({
                    ArrowFunctionExpression(path) {
                        // 箭头函数父级ExpressionStatement的leadingComments
                        let expStm = path.parentPath;
                        let lc = expStm.node.leadingComments;
                        if(lc.length) {
                            lastComment = lc[lc.length - 1];
                            if(lastComment.value === DEBUGGER_TAG) {
                                // 注释与箭头函数位置紧挨在一起
                                if(isSticked(lastComment, path.node)) {
                                    let IIFE_Expression = t.callExpression(path.node, []);
                                    expStm.node.expression = IIFE_Expression;
                                }
                            }
                        }
                    }
                });
            },
        }
    };
}


function isSticked(commentNode, arrowFunctionNode) {
    let result = false;
    // console.log(lastComment.loc.end.line, path.node.loc.start.line)
    if(commentNode && arrowFunctionNode) {
        if(commentNode.loc && arrowFunctionNode.loc) {
            if(commentNode.loc.end && arrowFunctionNode.loc.start) {
                result = (lastComment.loc.end.line + 1) === arrowFunctionNode.loc.start.line
            }
        }
    }
    return result;
}